package com.nokia.dingtalk_auto.service.task;

import java.io.File;
import java.io.IOException;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.Resource;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;

import com.fasterxml.jackson.databind.ObjectMapper;
import com.jcraft.jsch.JSchException;
import com.jcraft.jsch.SftpException;
import com.nokia.common.dingtalk.DingTalkUtil;
import com.nokia.common.dingtalk.exception.DingTalkApiException;
import com.nokia.common.jsch.SftpUtil;

/**
 * 向钉钉群发送投诉清单各地市投诉率
 */
@Service
public class TslTaskService {

    @Value("${tslTask.dingTalk.appKey:dingothmdq6opv6hjrm5}")
    private String appKey;

    @Value("${tslTask.dingTalk.appSecret:SeoyAwUnzFIFY4j4CX089HJ0i-pj1BIzByB3AZcnbCQaq94lZvazFpfEGGQwPznc}")
    private String appSecret;

    @Value("${tslTask.dingTalk.openConversationId:cidcWmmFwduUTDB3G0vPNOldQ==}")
    private String openConversationId;

    @Value("${tslTask.remoteDir:/data/report_auto/report}")
    private String remoteDir;

    @Value("${tslTask.localDir:./download}")
    private String localDir;

    @Value("${tslTask.remoteHost:133.96.94.105}")
    private String remoteHost;

    @Value("${tslTask.remotePort:22}")
    private int remotePort;

    @Value("${tslTask.remoteUser:do}")
    private String remoteUser;

    @Value("${tslTask.remotePassword:Richr00t}")
    private String remotePassword;

    @Resource
    private RestTemplate restTemplate;
    @Resource
    private RedisTemplate<String, Object> redisTemplate;
    @Resource
    private ObjectMapper objectMapper;

    // 完成指定日期的发送任务
    public void runTask(String day) {
        // 1. 下载文件
        download(day);
        // 2. 发送文件
        sendDingTalkMsg(day);
    }

    public void sendDingTalkMsg(String day) {
        DingTalkUtil dingTalkUtil = new DingTalkUtil(appKey, appSecret, openConversationId, restTemplate,
                redisTemplate, objectMapper);
        String localPath = localDir + "/" + day;
        File[] files = new File(localPath).listFiles();
        for (File file : files) {
            try {
                String mediaId = dingTalkUtil.upload(file.getAbsolutePath());
                Map<String, Object> map = new HashMap<>();
                map.put("photoURL", mediaId);
                dingTalkUtil.sendMsgWithRobot(map);
            } catch (DingTalkApiException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            }
        }
    }

    public void download(String day) {
        SftpUtil sftpUtil = new SftpUtil().setHost(remoteHost)
                .setPort(remotePort)
                .setUser(remoteUser)
                .setPassword(remotePassword);

        String remotePath = remoteDir + "/" + day;
        String localPath = localDir + "/" + day;

        File localFile = new File(localPath);
        if (!localFile.exists()) {
            localFile.mkdirs();
        }

        try {
            sftpUtil.connect();
            List<String> files = sftpUtil.ls(remotePath);
            for (String fileName : files) {
                if (fileName.endsWith(".png")) {
                    sftpUtil.get(remotePath + "/" + fileName, localPath + "/" + fileName);
                }
            }
        } catch (JSchException | SftpException | IOException e) {
            e.printStackTrace();
        } finally {
            sftpUtil.disconnect();
        }
    }
}
