package com.nokia.tsl_data.controller;

import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.nokia.common.http.R;
import com.nokia.tsl_data.service.TslWaraHouseService;
import com.nokia.tsl_data.vo.WarahouseManuallyRequest;

/**
 * 投诉率相关数据源入库
 */
@RequestMapping("/tsl/warahouse")
@RestController
public class TslWaraHouseConroller {

    private final TslWaraHouseService tslWaraHouseService;

    public TslWaraHouseConroller(TslWaraHouseService tslWaraHouseService) {
        this.tslWaraHouseService = tslWaraHouseService;
    }

    @PostMapping("/manually")
    public R warahouseManually(@RequestBody WarahouseManuallyRequest request) {
        if (request.getType().equalsIgnoreCase("MOBILE_COMP")) {
            tslWaraHouseService.waraHouseMobileComp(request.getDay());
        } else if (request.getType().equalsIgnoreCase("HIGH_QUALITY")) {
            tslWaraHouseService.waraHouseHighQuality(request.getDay());
        }
        return R.ok().message("入库成功");
    }
}
